diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/mac-tx-middle.cc ns-3.44/src/wifi/model/mac-tx-middle.cc
--- ns-3.43/src/wifi/model/mac-tx-middle.cc	2024-10-09 16:41:10.120656700 -0700
+++ ns-3.44/src/wifi/model/mac-tx-middle.cc	2025-03-09 16:55:49.791372500 -0700
@@ -40,7 +40,7 @@
 {
     NS_LOG_FUNCTION(this);
     uint16_t retval;
-    if (hdr->IsQosData() && !hdr->GetAddr1().IsGroup())
+    if (hdr->IsQosData() && !hdr->GetAddr1().IsBroadcast())
     {
         uint8_t tid = hdr->GetQosTid();
         NS_ASSERT(tid < 16);
@@ -78,7 +78,7 @@
 {
     NS_LOG_FUNCTION(this);
     uint16_t retval;
-    if (hdr->IsQosData() && !hdr->GetAddr1().IsGroup())
+    if (hdr->IsQosData() && !hdr->GetAddr1().IsBroadcast())
     {
         uint8_t tid = hdr->GetQosTid();
         NS_ASSERT(tid < 16);
@@ -118,7 +118,7 @@
 {
     NS_LOG_FUNCTION(this << *hdr);
 
-    if (hdr->IsQosData() && !hdr->GetAddr1().IsGroup())
+    if (hdr->IsQosData() && !hdr->GetAddr1().IsBroadcast())
     {
         uint8_t tid = hdr->GetQosTid();
         NS_ASSERT(tid < 16);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/mac-tx-middle.h ns-3.44/src/wifi/model/mac-tx-middle.h
--- ns-3.43/src/wifi/model/mac-tx-middle.h	2024-10-09 16:41:10.120656700 -0700
+++ ns-3.44/src/wifi/model/mac-tx-middle.h	2025-03-09 16:55:49.791372500 -0700
@@ -22,7 +22,7 @@
 class Mac48Address;
 
 /**
- * \ingroup wifi
+ * @ingroup wifi
  *
  * Handles sequence numbering of IEEE 802.11 data frames
  */
@@ -35,8 +35,8 @@
     /**
      * Return the next sequence number for the given header.
      *
-     * \param hdr Wi-Fi header
-     * \return the next sequence number
+     * @param hdr Wi-Fi header
+     * @return the next sequence number
      */
     uint16_t GetNextSequenceNumberFor(const WifiMacHeader* hdr);
     /**
@@ -44,23 +44,23 @@
      * the current sequence number remains unchanged). This functions is used for A-MPDU
      * aggregation.
      *
-     * \param hdr Wi-Fi header
-     * \return the next sequence number
+     * @param hdr Wi-Fi header
+     * @return the next sequence number
      */
     uint16_t PeekNextSequenceNumberFor(const WifiMacHeader* hdr);
     /**
      * Return the next sequence number for the Traffic ID and destination.
      *
-     * \param tid Traffic ID
-     * \param addr destination address
-     * \return the next sequence number
+     * @param tid Traffic ID
+     * @param addr destination address
+     * @return the next sequence number
      */
     uint16_t GetNextSeqNumberByTidAndAddress(uint8_t tid, Mac48Address addr) const;
     /**
      * Set the sequence number of the given MAC header as the next sequence
      * number for the Traffic ID and destination of the given MAC header.
      *
-     * \param hdr the given MAC header
+     * @param hdr the given MAC header
      */
     void SetSequenceNumberFor(const WifiMacHeader* hdr);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/mgt-action-headers.cc ns-3.44/src/wifi/model/mgt-action-headers.cc
--- ns-3.43/src/wifi/model/mgt-action-headers.cc	2024-10-09 16:41:10.120656700 -0700
+++ ns-3.44/src/wifi/model/mgt-action-headers.cc	2025-03-09 16:55:49.795372700 -0700
@@ -11,6 +11,7 @@
 #include "mgt-action-headers.h"
 
 #include "addba-extension.h"
+#include "gcr-group-address.h"
 
 #include "ns3/multi-link-element.h"
 #include "ns3/packet.h"
@@ -739,6 +740,13 @@
 void
 MgtAddBaRequestHeader::Print(std::ostream& os) const
 {
+    os << "A-MSDU support=" << m_amsduSupport << " Policy=" << +m_policy << " TID=" << +m_tid
+       << " Buffer size=" << m_bufferSize << " Timeout=" << m_timeoutValue
+       << " Starting seq=" << m_startingSeq;
+    if (m_gcrGroupAddress.has_value())
+    {
+        os << " GCR group address=" << m_gcrGroupAddress.value();
+    }
 }
 
 uint32_t
@@ -749,6 +757,11 @@
     size += 2; // Block ack parameter set
     size += 2; // Block ack timeout value
     size += 2; // Starting sequence control
+    if (m_gcrGroupAddress)
+    {
+        // a GCR Group Address element has to be added
+        size += GcrGroupAddress().GetSerializedSize();
+    }
     if (m_bufferSize >= 1024)
     {
         // an ADDBA Extension element has to be added
@@ -765,6 +778,12 @@
     i.WriteHtolsbU16(GetParameterSet());
     i.WriteHtolsbU16(m_timeoutValue);
     i.WriteHtolsbU16(GetStartingSequenceControl());
+    if (m_gcrGroupAddress)
+    {
+        GcrGroupAddress gcrGroupAddr;
+        gcrGroupAddr.m_gcrGroupAddress = *m_gcrGroupAddress;
+        i = gcrGroupAddr.Serialize(i);
+    }
     if (m_bufferSize >= 1024)
     {
         AddbaExtension addbaExt;
@@ -781,8 +800,16 @@
     SetParameterSet(i.ReadLsbtohU16());
     m_timeoutValue = i.ReadLsbtohU16();
     SetStartingSequenceControl(i.ReadLsbtohU16());
-    AddbaExtension addbaExt;
+    m_gcrGroupAddress.reset();
+    GcrGroupAddress gcrGroupAddr;
     auto tmp = i;
+    i = gcrGroupAddr.DeserializeIfPresent(i);
+    if (i.GetDistanceFrom(tmp) != 0)
+    {
+        m_gcrGroupAddress = gcrGroupAddr.m_gcrGroupAddress;
+    }
+    AddbaExtension addbaExt;
+    tmp = i;
     i = addbaExt.DeserializeIfPresent(i);
     if (i.GetDistanceFrom(tmp) != 0)
     {
@@ -842,6 +869,12 @@
     m_amsduSupport = supported;
 }
 
+void
+MgtAddBaRequestHeader::SetGcrGroupAddress(const Mac48Address& address)
+{
+    m_gcrGroupAddress = address;
+}
+
 uint8_t
 MgtAddBaRequestHeader::GetTid() const
 {
@@ -869,7 +902,7 @@
 bool
 MgtAddBaRequestHeader::IsAmsduSupported() const
 {
-    return m_amsduSupport == 1;
+    return m_amsduSupport;
 }
 
 uint16_t
@@ -884,11 +917,16 @@
     return (m_startingSeq << 4) & 0xfff0;
 }
 
+std::optional<Mac48Address>
+MgtAddBaRequestHeader::GetGcrGroupAddress() const
+{
+    return m_gcrGroupAddress;
+}
+
 uint16_t
 MgtAddBaRequestHeader::GetParameterSet() const
 {
-    uint16_t res = 0;
-    res |= m_amsduSupport;
+    uint16_t res = m_amsduSupport ? 1 : 0;
     res |= m_policy << 1;
     res |= m_tid << 2;
     res |= (m_bufferSize % 1024) << 6;
@@ -898,7 +936,7 @@
 void
 MgtAddBaRequestHeader::SetParameterSet(uint16_t params)
 {
-    m_amsduSupport = params & 0x01;
+    m_amsduSupport = ((params & 0x01) == 1);
     m_policy = (params >> 1) & 0x01;
     m_tid = (params >> 2) & 0x0f;
     m_bufferSize = (params >> 6) & 0x03ff;
@@ -929,7 +967,12 @@
 void
 MgtAddBaResponseHeader::Print(std::ostream& os) const
 {
-    os << "status code=" << m_code;
+    os << "Status code=" << m_code << "A-MSDU support=" << m_amsduSupport << " Policy=" << +m_policy
+       << " TID=" << +m_tid << " Buffer size=" << m_bufferSize << " Timeout=" << m_timeoutValue;
+    if (m_gcrGroupAddress.has_value())
+    {
+        os << " GCR group address=" << m_gcrGroupAddress.value();
+    }
 }
 
 uint32_t
@@ -940,6 +983,11 @@
     size += m_code.GetSerializedSize(); // Status code
     size += 2;                          // Block ack parameter set
     size += 2;                          // Block ack timeout value
+    if (m_gcrGroupAddress)
+    {
+        // a GCR Group Address element has to be added
+        size += GcrGroupAddress().GetSerializedSize();
+    }
     if (m_bufferSize >= 1024)
     {
         // an ADDBA Extension element has to be added
@@ -956,6 +1004,12 @@
     i = m_code.Serialize(i);
     i.WriteHtolsbU16(GetParameterSet());
     i.WriteHtolsbU16(m_timeoutValue);
+    if (m_gcrGroupAddress)
+    {
+        GcrGroupAddress gcrGroupAddr;
+        gcrGroupAddr.m_gcrGroupAddress = *m_gcrGroupAddress;
+        i = gcrGroupAddr.Serialize(i);
+    }
     if (m_bufferSize >= 1024)
     {
         AddbaExtension addbaExt;
@@ -972,8 +1026,16 @@
     i = m_code.Deserialize(i);
     SetParameterSet(i.ReadLsbtohU16());
     m_timeoutValue = i.ReadLsbtohU16();
-    AddbaExtension addbaExt;
+    m_gcrGroupAddress.reset();
+    GcrGroupAddress gcrGroupAddr;
     auto tmp = i;
+    i = gcrGroupAddr.DeserializeIfPresent(i);
+    if (i.GetDistanceFrom(tmp) != 0)
+    {
+        m_gcrGroupAddress = gcrGroupAddr.m_gcrGroupAddress;
+    }
+    AddbaExtension addbaExt;
+    tmp = i;
     i = addbaExt.DeserializeIfPresent(i);
     if (i.GetDistanceFrom(tmp) != 0)
     {
@@ -1027,6 +1089,12 @@
     m_amsduSupport = supported;
 }
 
+void
+MgtAddBaResponseHeader::SetGcrGroupAddress(const Mac48Address& address)
+{
+    m_gcrGroupAddress = address;
+}
+
 StatusCode
 MgtAddBaResponseHeader::GetStatusCode() const
 {
@@ -1060,14 +1128,19 @@
 bool
 MgtAddBaResponseHeader::IsAmsduSupported() const
 {
-    return m_amsduSupport == 1;
+    return m_amsduSupport;
+}
+
+std::optional<Mac48Address>
+MgtAddBaResponseHeader::GetGcrGroupAddress() const
+{
+    return m_gcrGroupAddress;
 }
 
 uint16_t
 MgtAddBaResponseHeader::GetParameterSet() const
 {
-    uint16_t res = 0;
-    res |= m_amsduSupport;
+    uint16_t res = m_amsduSupport ? 1 : 0;
     res |= m_policy << 1;
     res |= m_tid << 2;
     res |= (m_bufferSize % 1024) << 6;
@@ -1077,7 +1150,7 @@
 void
 MgtAddBaResponseHeader::SetParameterSet(uint16_t params)
 {
-    m_amsduSupport = params & 0x01;
+    m_amsduSupport = ((params & 0x01) == 1);
     m_policy = (params >> 1) & 0x01;
     m_tid = (params >> 2) & 0x0f;
     m_bufferSize = (params >> 6) & 0x03ff;
@@ -1108,6 +1181,11 @@
 void
 MgtDelBaHeader::Print(std::ostream& os) const
 {
+    os << "Initiator=" << m_initiator << " TID=" << +m_tid;
+    if (m_gcrGroupAddress.has_value())
+    {
+        os << " GCR group address=" << m_gcrGroupAddress.value();
+    }
 }
 
 uint32_t
@@ -1116,6 +1194,11 @@
     uint32_t size = 0;
     size += 2; // DelBa parameter set
     size += 2; // Reason code
+    if (m_gcrGroupAddress)
+    {
+        // a GCR Group Address element has to be added
+        size += GcrGroupAddress().GetSerializedSize();
+    }
     return size;
 }
 
@@ -1125,6 +1208,12 @@
     Buffer::Iterator i = start;
     i.WriteHtolsbU16(GetParameterSet());
     i.WriteHtolsbU16(m_reasonCode);
+    if (m_gcrGroupAddress)
+    {
+        GcrGroupAddress gcrGroupAddr;
+        gcrGroupAddr.m_gcrGroupAddress = *m_gcrGroupAddress;
+        i = gcrGroupAddr.Serialize(i);
+    }
 }
 
 uint32_t
@@ -1133,6 +1222,14 @@
     Buffer::Iterator i = start;
     SetParameterSet(i.ReadLsbtohU16());
     m_reasonCode = i.ReadLsbtohU16();
+    m_gcrGroupAddress.reset();
+    GcrGroupAddress gcrGroupAddr;
+    auto tmp = i;
+    i = gcrGroupAddr.DeserializeIfPresent(i);
+    if (i.GetDistanceFrom(tmp) != 0)
+    {
+        m_gcrGroupAddress = gcrGroupAddr.m_gcrGroupAddress;
+    }
     return i.GetDistanceFrom(start);
 }
 
@@ -1169,6 +1266,18 @@
     m_tid = static_cast<uint16_t>(tid);
 }
 
+void
+MgtDelBaHeader::SetGcrGroupAddress(const Mac48Address& address)
+{
+    m_gcrGroupAddress = address;
+}
+
+std::optional<Mac48Address>
+MgtDelBaHeader::GetGcrGroupAddress() const
+{
+    return m_gcrGroupAddress;
+}
+
 uint16_t
 MgtDelBaHeader::GetParameterSet() const
 {
@@ -1654,11 +1763,11 @@
 void
 FilsDiscHeader::FdCapability::SetOpChannelWidth(MHz_u width)
 {
-    m_chWidth = (width == 20 || width == 22) ? 0
-                : (width == 40)              ? 1
-                : (width == 80)              ? 2
-                : (width == 160)             ? 3
-                                             : 4;
+    m_chWidth = (width == MHz_u{20} || width == MHz_u{22}) ? 0
+                : (width == MHz_u{40})                     ? 1
+                : (width == MHz_u{80})                     ? 2
+                : (width == MHz_u{160})                    ? 3
+                                                           : 4;
 }
 
 MHz_u
@@ -1667,17 +1776,17 @@
     switch (m_chWidth)
     {
     case 0:
-        return m_phyIdx == 0 ? 22 : 20; // PHY Index 0 indicates 802.11b
+        return m_phyIdx == 0 ? MHz_u{22} : MHz_u{20}; // PHY Index 0 indicates 802.11b
     case 1:
-        return 40;
+        return MHz_u{40};
     case 2:
-        return 80;
+        return MHz_u{80};
     case 3:
-        return 160;
+        return MHz_u{160};
     default:
         NS_ABORT_MSG("Reserved value: " << +m_chWidth);
     }
-    return 0;
+    return MHz_u{0};
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.43/src/wifi/model/mgt-action-headers.h ns-3.44/src/wifi/model/mgt-action-headers.h
--- ns-3.43/src/wifi/model/mgt-action-headers.h	2024-10-09 16:41:10.120656700 -0700
+++ ns-3.44/src/wifi/model/mgt-action-headers.h	2025-03-09 16:55:49.795372700 -0700
@@ -18,6 +18,7 @@
 #include "wifi-standards.h"
 
 #include "ns3/header.h"
+#include "ns3/mac48-address.h"
 
 #include <list>
 #include <optional>
@@ -28,7 +29,7 @@
 class Packet;
 
 /**
- * \ingroup wifi
+ * @ingroup wifi
  *
  * See IEEE 802.11 chapter 7.3.1.11
  * Header format: | category: 1 | action value: 1 |
@@ -239,43 +240,43 @@
     /**
      * Set action for this Action header.
      *
-     * \param type category
-     * \param action action
+     * @param type category
+     * @param action action
      */
     void SetAction(CategoryValue type, ActionValue action);
 
     /**
      * Return the category value.
      *
-     * \return CategoryValue
+     * @return CategoryValue
      */
     CategoryValue GetCategory() const;
     /**
      * Return the action value.
      *
-     * \return ActionValue
+     * @return ActionValue
      */
     ActionValue GetAction() const;
 
     /**
      * Peek an Action header from the given packet.
      *
-     * \param pkt the given packet
-     * \return the category value and the action value in the peeked Action header
+     * @param pkt the given packet
+     * @return the category value and the action value in the peeked Action header
      */
     static std::pair<CategoryValue, ActionValue> Peek(Ptr<const Packet> pkt);
 
     /**
      * Remove an Action header from the given packet.
      *
-     * \param pkt the given packet
-     * \return the category value and the action value in the removed Action header
+     * @param pkt the given packet
+     * @return the category value and the action value in the removed Action header
      */
     static std::pair<CategoryValue, ActionValue> Remove(Ptr<Packet> pkt);
 
     /**
      * Register this type.
-     * \return The TypeId.
+     * @return The TypeId.
      */
     static TypeId GetTypeId();
     TypeId GetInstanceTypeId() const override;
@@ -290,7 +291,7 @@
 };
 
 /**
- * \ingroup wifi
+ * @ingroup wifi
  * Implement the header for management frames of type Add Block Ack request.
  */
 class MgtAddBaRequestHeader : public Header
@@ -298,7 +299,7 @@
   public:
     /**
      * Register this type.
-     * \return The TypeId.
+     * @return The TypeId.
      */
     static TypeId GetTypeId();
     TypeId GetInstanceTypeId() const override;
@@ -318,108 +319,119 @@
     /**
      * Set Traffic ID (TID).
      *
-     * \param tid traffic ID
+     * @param tid traffic ID
      */
     void SetTid(uint8_t tid);
     /**
      * Set timeout.
      *
-     * \param timeout timeout
+     * @param timeout timeout
      */
     void SetTimeout(uint16_t timeout);
     /**
      * Set buffer size.
      *
-     * \param size buffer size
+     * @param size buffer size
      */
     void SetBufferSize(uint16_t size);
     /**
      * Set the starting sequence number.
      *
-     * \param seq the starting sequence number
+     * @param seq the starting sequence number
      */
     void SetStartingSequence(uint16_t seq);
     /**
      * Enable or disable A-MSDU support.
      *
-     * \param supported enable or disable A-MSDU support
+     * @param supported enable or disable A-MSDU support
      */
     void SetAmsduSupport(bool supported);
+    /**
+     * Set the GCR Group address.
+     *
+     * @param address the GCR Group Address
+     */
+    void SetGcrGroupAddress(const Mac48Address& address);
 
     /**
      * Return the starting sequence number.
      *
-     * \return the starting sequence number
+     * @return the starting sequence number
      */
     uint16_t GetStartingSequence() const;
     /**
      * Return the Traffic ID (TID).
      *
-     * \return TID
+     * @return TID
      */
     uint8_t GetTid() const;
     /**
      * Return whether the Block Ack policy is immediate Block Ack.
      *
-     * \return true if immediate Block Ack is being used, false otherwise
+     * @return true if immediate Block Ack is being used, false otherwise
      */
     bool IsImmediateBlockAck() const;
     /**
      * Return the timeout.
      *
-     * \return timeout
+     * @return timeout
      */
     uint16_t GetTimeout() const;
     /**
      * Return the buffer size.
      *
-     * \return the buffer size.
+     * @return the buffer size.
      */
     uint16_t GetBufferSize() const;
     /**
      * Return whether A-MSDU capability is supported.
      *
-     * \return true is A-MSDU is supported, false otherwise
+     * @return true is A-MSDU is supported, false otherwise
      */
     bool IsAmsduSupported() const;
+    /**
+     * @return the GCR Group Address, if present
+     */
+    std::optional<Mac48Address> GetGcrGroupAddress() const;
 
   private:
     /**
      * Return the raw parameter set.
      *
-     * \return the raw parameter set
+     * @return the raw parameter set
      */
     uint16_t GetParameterSet() const;
     /**
      * Set the parameter set from the given raw value.
      *
-     * \param params raw parameter set value
+     * @param params raw parameter set value
      */
     void SetParameterSet(uint16_t params);
     /**
      * Return the raw sequence control.
      *
-     * \return the raw sequence control
+     * @return the raw sequence control
      */
     uint16_t GetStartingSequenceControl() const;
     /**
      * Set sequence control with the given raw value.
      *
-     * \param seqControl the raw sequence control
+     * @param seqControl the raw sequence control
      */
     void SetStartingSequenceControl(uint16_t seqControl);
 
-    uint8_t m_dialogToken{1};   //!< Not used for now
-    uint8_t m_amsduSupport{1};  //!< Flag if A-MSDU is supported
-    uint8_t m_policy{1};        //!< Block Ack policy
-    uint8_t m_tid{0};           //!< Traffic ID
-    uint16_t m_bufferSize{0};   //!< Buffer size
-    uint16_t m_timeoutValue{0}; //!< Timeout
-    uint16_t m_startingSeq{0};  //!< Starting sequence number
+    uint8_t m_dialogToken{1};                      //!< Not used for now
+    bool m_amsduSupport{true};                     //!< Flag if A-MSDU is supported
+    uint8_t m_policy{1};                           //!< Block Ack policy
+    uint8_t m_tid{0};                              //!< Traffic ID
+    uint16_t m_bufferSize{0};                      //!< Buffer size
+    uint16_t m_timeoutValue{0};                    //!< Timeout
+    uint16_t m_startingSeq{0};                     //!< Starting sequence number
+    std::optional<Mac48Address> m_gcrGroupAddress; //!< GCR Group Address (optional)
 };
 
 /**
- * \ingroup wifi
+ * @ingroup wifi
  * Implement the header for management frames of type Add Block Ack response.
  */
 class MgtAddBaResponseHeader : public Header
@@ -427,7 +439,7 @@
   public:
     /**
      * Register this type.
-     * \return The TypeId.
+     * @return The TypeId.
      */
     static TypeId GetTypeId();
     TypeId GetInstanceTypeId() const override;
@@ -447,96 +459,107 @@
     /**
      * Set Traffic ID (TID).
      *
-     * \param tid traffic ID
+     * @param tid traffic ID
      */
     void SetTid(uint8_t tid);
     /**
      * Set timeout.
      *
-     * \param timeout timeout
+     * @param timeout timeout
      */
     void SetTimeout(uint16_t timeout);
     /**
      * Set buffer size.
      *
-     * \param size buffer size
+     * @param size buffer size
      */
     void SetBufferSize(uint16_t size);
     /**
      * Set the status code.
      *
-     * \param code the status code
+     * @param code the status code
      */
     void SetStatusCode(StatusCode code);
     /**
      * Enable or disable A-MSDU support.
      *
-     * \param supported enable or disable A-MSDU support
+     * @param supported enable or disable A-MSDU support
      */
     void SetAmsduSupport(bool supported);
+    /**
+     * Set the GCR Group address.
+     *
+     * @param address the GCR Group Address
+     */
+    void SetGcrGroupAddress(const Mac48Address& address);
 
     /**
      * Return the status code.
      *
-     * \return the status code
+     * @return the status code
      */
     StatusCode GetStatusCode() const;
     /**
      * Return the Traffic ID (TID).
      *
-     * \return TID
+     * @return TID
      */
     uint8_t GetTid() const;
     /**
      * Return whether the Block Ack policy is immediate Block Ack.
      *
-     * \return true if immediate Block Ack is being used, false otherwise
+     * @return true if immediate Block Ack is being used, false otherwise
      */
     bool IsImmediateBlockAck() const;
     /**
      * Return the timeout.
      *
-     * \return timeout
+     * @return timeout
      */
     uint16_t GetTimeout() const;
     /**
      * Return the buffer size.
      *
-     * \return the buffer size.
+     * @return the buffer size.
      */
     uint16_t GetBufferSize() const;
     /**
      * Return whether A-MSDU capability is supported.
      *
-     * \return true is A-MSDU is supported, false otherwise
+     * @return true is A-MSDU is supported, false otherwise
      */
     bool IsAmsduSupported() const;
+    /**
+     * @return the GCR Group Address, if present
+     */
+    std::optional<Mac48Address> GetGcrGroupAddress() const;
 
   private:
     /**
      * Return the raw parameter set.
      *
-     * \return the raw parameter set
+     * @return the raw parameter set
      */
     uint16_t GetParameterSet() const;
     /**
      * Set the parameter set from the given raw value.
      *
-     * \param params raw parameter set value
+     * @param params raw parameter set value
      */
     void SetParameterSet(uint16_t params);
 
-    uint8_t m_dialogToken{1};   //!< Not used for now
-    StatusCode m_code{};        //!< Status code
-    uint8_t m_amsduSupport{1};  //!< Flag if A-MSDU is supported
-    uint8_t m_policy{1};        //!< Block ACK policy
-    uint8_t m_tid{0};           //!< Traffic ID
-    uint16_t m_bufferSize{0};   //!< Buffer size
-    uint16_t m_timeoutValue{0}; //!< Timeout
+    uint8_t m_dialogToken{1};                      //!< Not used for now
+    StatusCode m_code{};                           //!< Status code
+    bool m_amsduSupport{true};                     //!< Flag if A-MSDU is supported
+    uint8_t m_policy{1};                           //!< Block ACK policy
+    uint8_t m_tid{0};                              //!< Traffic ID
+    uint16_t m_bufferSize{0};                      //!< Buffer size
+    uint16_t m_timeoutValue{0};                    //!< Timeout
+    std::optional<Mac48Address> m_gcrGroupAddress; //!< GCR Group Address (optional)
 };
 
 /**
- * \ingroup wifi
+ * @ingroup wifi
  * Implement the header for management frames of type Delete Block Ack.
  */
 class MgtDelBaHeader : public Header
@@ -544,7 +567,7 @@
   public:
     /**
      * Register this type.
-     * \return The TypeId.
+     * @return The TypeId.
      */
     static TypeId GetTypeId();
 
@@ -557,20 +580,20 @@
     /**
      * Check if the initiator bit in the DELBA is set.
      *
-     * \return true if the initiator bit in the DELBA is set,
+     * @return true if the initiator bit in the DELBA is set,
      *         false otherwise
      */
     bool IsByOriginator() const;
     /**
      * Return the Traffic ID (TID).
      *
-     * \return TID
+     * @return TID
      */
     uint8_t GetTid() const;
     /**
      * Set Traffic ID (TID).
      *
-     * \param tid traffic ID
+     * @param tid traffic ID
      */
     void SetTid(uint8_t tid);
     /**
@@ -581,28 +604,39 @@
      * Un-set the initiator bit in the DELBA.
      */
     void SetByRecipient();
+    /**
+     * Set the GCR Group address.
+     *
+     * @param address the GCR Group Address
+     */
+    void SetGcrGroupAddress(const Mac48Address& address);
+    /**
+     * @return the GCR Group Address, if present
+     */
+    std::optional<Mac48Address> GetGcrGroupAddress() const;
 
   private:
     /**
      * Return the raw parameter set.
      *
-     * \return the raw parameter set
+     * @return the raw parameter set
      */
     uint16_t GetParameterSet() const;
     /**
      * Set the parameter set from the given raw value.
      *
-     * \param params raw parameter set value
+     * @param params raw parameter set value
      */
     void SetParameterSet(uint16_t params);
 
     uint16_t m_initiator{0};  //!< initiator
     uint16_t m_tid{0};        //!< Traffic ID
     uint16_t m_reasonCode{1}; //!< Not used for now. Always set to 1: "Unspecified reason"
+    std::optional<Mac48Address> m_gcrGroupAddress; //!< GCR Group Address (optional)
 };
 
 /**
- * \ingroup wifi
+ * @ingroup wifi
  * Implement the header for Action frames of type EML Operating Mode Notification.
  */
 class MgtEmlOmn : public Header
@@ -612,7 +646,7 @@
 
     /**
      * Register this type.
-     * \return The TypeId.
+     * @return The TypeId.
      */
     static TypeId GetTypeId();
     TypeId GetInstanceTypeId() const override;
@@ -647,11 +681,11 @@
     /**
      * Set the bit position in the link bitmap corresponding to the given link.
      *
-     * \param linkId the ID of the given link
+     * @param linkId the ID of the given link
      */
     void SetLinkIdInBitmap(uint8_t linkId);
     /**
-     * \return the ID of the links whose bit position in the link bitmap is set to 1
+     * @return the ID of the links whose bit position in the link bitmap is set to 1
      */
     std::list<uint8_t> GetLinkBitmap() const;
 
@@ -661,7 +695,7 @@
 };
 
 /**
- * \ingroup wifi
+ * @ingroup wifi
  * Implement the FILS (Fast Initial Link Setup) action frame.
  * See sec. 9.6.7.36 of IEEE 802.11-2020 and IEEE 802.11ax-2021.
  */
@@ -670,7 +704,7 @@
   public:
     FilsDiscHeader();
 
-    /// \return the object TypeId
+    /// @return the object TypeId
     static TypeId GetTypeId();
     TypeId GetInstanceTypeId() const override;
     void Print(std::ostream& os) const override;
@@ -681,20 +715,20 @@
     /**
      * Set the SSID field.
      *
-     * \param ssid the SSID
+     * @param ssid the SSID
      */
     void SetSsid(const std::string& ssid);
 
-    /// \return the SSID
+    /// @return the SSID
     const std::string& GetSsid() const;
 
-    /// \return size of FILS Discovery Information field in octets
+    /// @return size of FILS Discovery Information field in octets
     uint32_t GetInformationFieldSize() const;
 
-    /// \return size of non-optional subfields in octets
+    /// @return size of non-optional subfields in octets
     uint32_t GetSizeNonOptSubfields() const;
 
-    /// \brief sets value of Length subfield
+    /// @brief sets value of Length subfield
     void SetLengthSubfield();
 
     /// FILS Discovery Frame Control subfield of FILS Discovery Information field
@@ -714,15 +748,15 @@
         uint8_t m_reserved : 2 {0};              ///< Reserved Bits
 
         /**
-         * \brief serialize content to a given buffer
-         * \param start given input buffer iterator
+         * @brief serialize content to a given buffer
+         * @param start given input buffer iterator
          */
         void Serialize(Buffer::Iterator& start) const;
 
         /**
-         * \brief read content from a given buffer
-         * \param start input buffer iterator
-         * \return number of read octets
+         * @brief read content from a given buffer
+         * @param start input buffer iterator
+         * @return number of read octets
          */
         uint32_t Deserialize(Buffer::Iterator start);
     };
@@ -740,17 +774,17 @@
         uint8_t m_minRate : 3 {0};               ///< FILS Minimum Rate
 
         /**
-         * \brief Set the BSS Operating Channel Width field based on the operating channel width
-         * \param width the operating channel width
+         * @brief Set the BSS Operating Channel Width field based on the operating channel width
+         * @param width the operating channel width
          */
         void SetOpChannelWidth(MHz_u width);
 
-        /// \return the operating channel width encoded in the BSS Operating Channel Width field
+        /// @return the operating channel width encoded in the BSS Operating Channel Width field
         MHz_u GetOpChannelWidth() const;
 
         /**
-         * \brief Set the Maximum Number of Spatial Streams field
-         * \param maxNss the maximum number of supported spatial streams
+         * @brief Set the Maximum Number of Spatial Streams field
+         * @param maxNss the maximum number of supported spatial streams
          */
         void SetMaxNss(uint8_t maxNss);
 
@@ -758,33 +792,33 @@
          * Note that this function returns 5 if the maximum number of supported spatial streams
          * is greater than 4.
          *
-         * \return the maximum number of supported spatial streams
+         * @return the maximum number of supported spatial streams
          */
         uint8_t GetMaxNss() const;
 
         /**
-         * \brief Set the PHY Index field based on the given wifi standard
-         * \param standard the wifi standard
+         * @brief Set the PHY Index field based on the given wifi standard
+         * @param standard the wifi standard
          */
         void SetStandard(WifiStandard standard);
 
         /**
-         * \param band the PHY band in which the device is operating (needed to distinguish
+         * @param band the PHY band in which the device is operating (needed to distinguish
          *             between 802.11a and 802.11g)
-         * \return the wifi standard encoded in the PHY Index field
+         * @return the wifi standard encoded in the PHY Index field
          */
         WifiStandard GetStandard(WifiPhyBand band) const;
 
         /**
-         * \brief serialize content to a given buffer
-         * \param start given input buffer iterator
+         * @brief serialize content to a given buffer
+         * @param start given input buffer iterator
          */
         void Serialize(Buffer::Iterator& start) const;
 
         /**
-         * \brief read content from a given buffer
-         * \param start input buffer iterator
-         * \return number of read octets
+         * @brief read content from a given buffer
+         * @param start input buffer iterator
+         * @return number of read octets
          */
         uint32_t Deserialize(Buffer::Iterator start);
     };
@@ -812,20 +846,20 @@
 };
 
 /**
- * \brief Stream insertion operator.
+ * @brief Stream insertion operator.
  *
- * \param os the output stream
- * \param control the Fils Discovery Frame Control field
- * \returns a reference to the stream
+ * @param os the output stream
+ * @param control the Fils Discovery Frame Control field
+ * @returns a reference to the stream
  */
 std::ostream& operator<<(std::ostream& os, const FilsDiscHeader::FilsDiscFrameControl& control);
 
 /**
- * \brief Stream insertion operator.
+ * @brief Stream insertion operator.
  *
- * \param os the output stream
- * \param capability the Fils Discovery Frame Capability field
- * \returns a reference to the stream
+ * @param os the output stream
+ * @param capability the Fils Discovery Frame Capability field
+ * @returns a reference to the stream
  */
 std::ostream& operator<<(std::ostream& os, const FilsDiscHeader::FdCapability& capability);
 
